/**
 * This file is part of Rubanetra.
 * Copyright (C) 2013,2014 Stefan Swerk (stefan_rubanetra@swerk.priv.at)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
import at.jku.fim.rubanetra.config.model.PortSpecification;
import at.jku.fim.rubanetra.protocol.activity.AbstractActivity;
import at.jku.fim.rubanetra.protocol.mapper.KrakenTransportLayerMappingFactory;
import org.junit.Test;
import org.kie.api.definition.type.FactType;

import java.util.Collection;

import static org.junit.Assert.assertFalse;

/**
 * Created by stefan on 1/15/14.
 */
public class SkypeTest extends TestBase {
    private final String skypeFilePath = "captures/03.skype.irc.cap";

    public void initializeDefaultSkypeConfig(String pcapPath) {
        initializePcapHandler(pcapPath);
        addDefaultDnsSupport();

        protoBuilder.resetCurrentProtocolConfiguration();
        protoBuilder.bindProtocol("ethernet", "ipv4").bindProtocol("ipv4", "udp");
        protoBuilder.setPcapHandler(pcapHandler);
        protoBuilder.setPortSpecification(PortSpecification.UniversalPortSpecification.ACCEPT_ALL);
        protoBuilder.setTransportProtocolMappingStrategy(KrakenTransportLayerMappingFactory.DESTINATION_PORT_STRATEGY);
        protoBuilder.setTransportProtocolMappingFactory(transportProtocolMappingFactory);
        sysBuilder.addProtocolSetting(protoBuilder.buildProtocolConfiguration());
        setRubanetraSystemConfiguration(sysBuilder.build());
    }

    @Test
    public void skypeTest() {
        initializeDefaultSkypeConfig(skypeFilePath);
        while (pcapHandler.readNextPcapEntry(droolsHandler)) ;
        final Collection<?> tlsActivities = systemConfiguration.getKieSession().
                getObjects(object -> object.getClass().getSimpleName().equals("SkypePayloadActivity"));
        FactType dropboxType = systemConfiguration.getKieSession().getKieBase().getFactType("at.jku.fim.forensic.network.analysis", "SkypePayloadActivity");
//        for (Object o : tlsActivities) {
//            AbstractActivity a = (AbstractActivity) o;
////            System.out.println(((DnsActivity) dropboxType.get(a, "dnsQuestion")).getDnsMessage().getQuestion().getName());
//            System.out.println(a.getCompoundFrameNumbers());
//            System.out.println(a);
//        }
        assertFalse(tlsActivities.isEmpty());
    }

}
